#include <iostream>
#include <cstdlib>

using std::exit;

#include "cmyk.hh"
#include "hsv.hh"
#include "ycbcr.hh"
#include "ycc.hh"
#include "yiq.hh"
#include "ypbpr.hh"
#include "yuv.hh"

#define spacecount 7
static Colorspace *Spaces[spacecount] =
{ new CMYK, new HSV,
  new YCbCr, new YCC, new YIQ, new YPbPr, new YUV };
static RGB rgb;

static void UpdateSpaces(unsigned butnot = spacecount)
{
    for(unsigned a=0; a<spacecount; ++a)
        if(a != butnot)
            Spaces[a]->Set(rgb);
}
static void UpdateRGB(unsigned fromspace)
{
    if(fromspace >= spacecount)
    {
        cerr << "UpdateRGB: " << fromspace << " >= " << spacecount << endl;
        exit(-1);
    }
    rgb = Spaces[fromspace]->Get();
}

int main(void)
{
    rgb.r = 1; rgb.g = 0; rgb.b = 0;
    UpdateSpaces();

    return 0;
}
