#ifndef bqtYspaceHH
#define bqtYspaceHH

#include "colorspace.hh"

class yspace : public Colorspace
{
    double Y, p1, p2;
public:
    virtual double Y_r() const = 0;
    virtual double p1_r() const = 0;
    virtual double p2_r() const = 0;
    virtual double Y_g() const = 0;
    virtual double p1_g() const = 0;
    virtual double p2_g() const = 0;
    virtual double Y_b() const = 0;
    virtual double p1_b() const = 0;
    virtual double p2_b() const = 0;
    virtual double r_Y() const = 0;
    virtual double r_p1() const = 0;
    virtual double r_p2() const = 0;
    virtual double g_Y() const = 0;
    virtual double g_p1() const = 0;
    virtual double g_p2() const = 0;
    virtual double b_Y() const = 0;
    virtual double b_p1() const = 0;
    virtual double b_p2() const = 0;
    
    virtual void Set(const RGB &rgb)
    {
        Y = rgb.r * r_Y() + rgb.g * g_Y() + rgb.b * b_Y();
        p1= rgb.r * r_p1() + rgb.g * g_p1() + rgb.b * b_p1();
        p2= rgb.r * r_p2() + rgb.g * g_p2() + rgb.b * b_p2();
    }
    virtual RGB Get() const
    {
        RGB tmp;
        tmp.r = Y * Y_r() + p1 * p1_r() + p2 * p2_r();
        tmp.g = Y * Y_g() + p1 * p1_g() + p2 * p2_g();
        tmp.b = Y * Y_b() + p1 * p1_b() + p2 * p2_b();
        return tmp;
    }

    virtual double Value1() const { return Y; }
    virtual double Value2() const { return p1; }
    virtual double Value3() const { return p2; }
    virtual void SetValue1(double v) { Y=v; }
    virtual void SetValue2(double v) { p1=v; }
    virtual void SetValue3(double v) { p2=v; }
};

#endif
